[indent=4]

uses
    Gtk

class Pictureviewclass    
    
    pixbuf : Gdk.Pixbuf
    pixbufsuccess : bool
    rotation : int
    vbox : VBox
    cbscale : CheckButton
    hbox_toolbuttons : HBox
    hbox_runbuttons : HBox
    hbox_top : HBox
    hbox_bottom : HBox

    zoomspin : SpinButton
    image : Image
    scrolledwindow : ScrolledWindow
    eventbox : EventBox
    vp : Viewport
    run_button_array : array of string
    run_button_counter : int
    filename : Entry

    
    current_file : string
    
    def init()
        
        filename = new Entry()

        
        run_button_array = new array of string [20]
        run_button_counter = 0
        
        
        vbox = new VBox(false , 1)
        vbox.spacing = 5
        
        hbox_top = new HBox(true , 1) 
        vbox.pack_start (hbox_top, false, true, 0)
        
        
        scrolledwindow = new ScrolledWindow(null , null)
        scrolledwindow.set_policy(Gtk.PolicyType.AUTOMATIC , Gtk.PolicyType.AUTOMATIC )
        scrolledwindow.set_shadow_type(Gtk.ShadowType.NONE)
        
        vbox.pack_start (scrolledwindow, true, true, 0)
        eventbox = new EventBox()
        scrolledwindow.add_with_viewport(eventbox)
        

        
        var widget = (Widget) eventbox
        var parent = widget.get_parent()
        var ev = (Viewport) parent
        ev.set_shadow_type(Gtk.ShadowType.NONE)
        image = new Image()
        eventbox.add(image)

        
        hbox_bottom = new HBox(true , 1)          
        vbox.pack_start (hbox_bottom, false, true, 0)
        
        hbox_toolbuttons = new HBox(false , 1)
        hbox_toolbuttons.spacing = 5
        hbox_top.pack_start(hbox_toolbuttons , false , true , 0)

        hbox_runbuttons = new HBox(false , 1) 
        hbox_runbuttons.spacing = 5        
        hbox_bottom.pack_start(hbox_runbuttons , false , true , 0)
        

        
        var rotate1 = new Button.with_label("-90°")
        hbox_toolbuttons.pack_start(rotate1 , true, true, 0)
        rotate1.clicked += rotate_left

        var rotate0 = new Button.with_label("0°")
        hbox_toolbuttons.pack_start(rotate0 , true, true, 0)
        rotate0.clicked += rotate_none
        
        var rotate2 = new Button.with_label("+90°") 
        hbox_toolbuttons.pack_start(rotate2 , true, true, 0)        
        rotate2.clicked += rotate_right        
        
        zoomspin = new SpinButton.with_range(100, 1000,100)
        hbox_toolbuttons.pack_start(zoomspin , true, true, 0)

        zoomspin.changed += zoom 
        
        cbscale = new CheckButton()
        cbscale.set_label("scale")
        cbscale.set_active(true)
        hbox_toolbuttons.pack_start(cbscale , false, false, 0)
        cbscale.clicked += scale_picture 


        //eventbox.drag_dest_set()

        /* setup window as drag dest */
        entry : array of TargetEntry
        entry = TargetEntry[0]
        //entry[1].flags = 0
        
        //target_entry : TargetEntry
        //target_entry : array of TargetEntry = { "text/uri-list" , 1 } 
        var dlist = new Gtk.TargetList(entry)
        dlist.add_uri_targets(0)
        dlist.add_text_targets(0)

        Gtk.drag_dest_set(eventbox, Gtk.DestDefaults.ALL,entry, Gdk.DragAction.MOVE | Gdk.DragAction.COPY);



        //Gtk.drag_dest_set(eventbox, Gtk.DestDefaults.ALL, entry, Gdk.DragAction.DEFAULT | Gdk.DragAction.COPY);
        Gtk.drag_dest_set_target_list(eventbox, dlist);


        //target_entry : TargetEntry
        //target_entry[3]
         
        return 
    
    def add_run_button(title : string , action : string)
    
        var b = new Button.with_label(title) 
        b.button_release_event += run_program 
        
        run_button_array [run_button_counter] = action
        b.name = "runbutton_" + run_button_counter.to_string()
        run_button_counter++
        hbox_runbuttons.pack_start (b, true, true, 0)

    
        return
 
    def run_program(b : Button , eventbutton : Gdk.EventButton) : bool

        var name = b.name
        var a = name.split("_")

        
        var thecmd = run_button_array[a[1].to_int()] + " \"" + current_file + "\""
        //print("%s" , thecmd)        
        try
            Process.spawn_command_line_async(thecmd)
        except ex : GLib.Error
            print("%s", "exec failed!")

    
        return false
 
    def on_size_request()

        //-- if window resizes...
        //.. rescale the displayed image...

        if not cbscale.get_active()
            return

        scale_picture()
 
    def load_file(thefile : string)

        
        var suffix= thefile.rchr(-1,'.').down()


        
        var load = false
        if suffix is ".jpg"
            load = true
    
        if suffix is ".jpeg"
            load = true
                
        if suffix is ".png"
            load = true   
        
        if suffix is ".bmp"
            load = true
        
        if suffix is ".gif"
            load = true   
         
        if suffix is ".xpm"
            load = true   
         
        if load is false
            return
        

        try
            pixbuf= new Gdk.Pixbuf.from_file(thefile)
            pixbufsuccess = true
            current_file = thefile
            filename.set_text(thefile)
        except ex : GLib.Error
            print("%s", "load pixbuf failed!") 
            pixbufsuccess = false
        
  
        rotation = 0   
        scale_picture()


    def rotate_left()
    
        rotation = 1
        scale_picture()


    def rotate_right()
    
        rotation = 2
        scale_picture()
    
    def rotate_none()
    
        rotation = 0
        scale_picture()
        
    def zoom()
        cbscale.set_active(false)
        scale_picture()
    
    def scale_picture()

        if pixbufsuccess is false
            return
    
    
        pixbufcopy : Gdk.Pixbuf

        pixbufcopy = pixbuf

        if rotation is 0
            pixbufcopy = pixbuf.copy()

        if rotation is 1
            pixbufcopy = pixbuf.rotate_simple(Gdk.PixbufRotation.COUNTERCLOCKWISE)
        
        if rotation is 2
            pixbufcopy = pixbuf.rotate_simple(Gdk.PixbufRotation.CLOCKWISE)   
    
        var scale = cbscale.get_active()
    
        var pw = pixbufcopy.width
        var ph = pixbufcopy.height
    
        if not scale
    
            
            var zoom = zoomspin.get_value()
    
            if zoom is 100
                image.set_from_pixbuf(pixbufcopy)
            else
                pixbufcopy = pixbufcopy.scale_simple((int) (pw * zoom /100), (int) (ph * zoom / 100)  , Gdk.InterpType.HYPER)
                image.set_from_pixbuf(pixbufcopy)
        
            pixbufcopy = null
            return 



        //-- calculate the size for the image --
        var ww=0
        var wh=0


        ww = scrolledwindow.allocation.width
        wh = scrolledwindow.allocation.height
    
        w : float
        h : float

        var aspect = (float)pw /  (float)ph
        
        w = (float)ww
        h = (float)ww / aspect
            
        if (int)h > wh
            //print ("%s" , "AAA")
            h = (float) wh
            w = h * aspect
            

        pixbufcopy = pixbufcopy.scale_simple((int)w, (int)h , Gdk.InterpType.HYPER)
        image.set_from_pixbuf(pixbufcopy)
    
        pixbufcopy = null

    def load_picture(uristring : string)
        
        var uri = uristring.replace("\\" , "/")
        uri = uri.replace("file:///" , "")

        
        var suffix= uri.rchr(-1,'.').down()

        //print("%s" , uri)
        
        var load = false
        if suffix is ".jpg"
            load = true
    
        if suffix is ".jpeg"
            load = true
                
        if suffix is ".png"
            load = true   
        
        if suffix is ".bmp"
            load = true
        
        if suffix is ".gif"
            load = true   
         
        if suffix is ".xpm"
            load = true   
         
        if load is false
            return 
            
        if uri.substring(0,5) is "http:"
            download_and_show(uri)
        else
            if uri.substring(0,4) is "ftp:"
                download_and_show(uri)        
            else
                uri = "file:///" + uri
                uri = Filename.from_uri(uri)
                load_file(uri)
                
               


    def download_and_show(uri : string)

        var suffix= uri.rchr(-1,'.').down()
        var thecmd = "wget -O /tmp/TEMP-file" + suffix + " " + uri + " 2>/dev/null"
        run (thecmd)
        load_file("/tmp/TEMP-file" + suffix)


    def run(thecmd : string)
        try
            Process.spawn_command_line_sync(thecmd)
        except ex : GLib.Error
            print("%s", "exec failed!")



